#include "StdAfx.h"
#include "PlainUrl.h"


CPlainUrl::CPlainUrl( const VECSTRS& vecStrs, const VECRECTS& vecRects, const VECRANGES& vecRangs )
{
	m_vecStrs		= vecStrs;
	m_vecRects		= vecRects;
	m_vecRanges		= vecRangs;
}

CPlainUrl::~CPlainUrl(void)
{
}

void CPlainUrl::Extract()
{
   _ExtractUrlInfo();
}

void CPlainUrl::_ExtractUrlInfo()
{
	int nRangeCount = m_vecRanges.size();
	
	for(int nIndex = 0; nIndex < nRangeCount; nIndex++)
	{
		TextRange textRange = m_vecRanges[nIndex];
		int nLineBeginPos = -1;
		int nLineEndPos = 0;
		int nLines = m_vecStrs.size();

		for(int nLine = 0; nLine < nLines; nLine++)
		{
			TextRange textRangePerLine;
			textRangePerLine.Reset();
			//textRange.nStart -= nLineBeginPos;
			//textRange.nEnd -= nLineBeginPos;
			nLineEndPos = nLineBeginPos + m_vecStrs[nLine].GetLength();
			
			if(textRange.nStart > nLineBeginPos && textRange.nStart < nLineEndPos)
			{
				textRangePerLine.nStart = textRange.nStart - nLineBeginPos - 1;
			}
			else
			{
				textRangePerLine.nStart = 0;
			}

			if(textRange.nEnd >= nLineBeginPos && textRange.nEnd <= nLineEndPos)
			{
				textRangePerLine.nEnd = textRange.nEnd - nLineBeginPos;
			}
			else
			{
				textRangePerLine.nEnd =  m_vecStrs[nLine].GetLength();
			}

			if(textRange.nStart > nLineEndPos || textRange.nEnd < nLineBeginPos)
			{
				textRangePerLine.Reset();
			}

			if(textRangePerLine.IsValid())
			{
				 URL_INFO urlInfo;
				 urlInfo.nIndex = nIndex;
				 urlInfo.nLine = nLine;
				 urlInfo.textRangeInStr = textRangePerLine;

				 m_vecUrlInfos.push_back(urlInfo);
			}

			if(textRange.nEnd - nLineEndPos == 1)
			{
				break;
			}
			nLineBeginPos = nLineEndPos;
		}
	}
	
}

VECRANGES CPlainUrl::GetUrlRangeByLine( int nLine )
{
	VECRANGES vecRet;
	for (int i = 0; i < m_vecUrlInfos.size(); i++)
	{
		URL_INFO urlInfo = (URL_INFO)m_vecUrlInfos[i];
		if(urlInfo.nLine == nLine)
		{
			vecRet.push_back(urlInfo.textRangeInStr);
		}
	}
	
	return vecRet;
}
